package generator.xml;
import java.util.ArrayList;
import java.util.List;

public class GenericType extends AbstractType {
	private List<AbstractType> types = new ArrayList<AbstractType>();
	
	public GenericType(String type) {
		this.type = type.substring(0, type.indexOf("<"));
		String genericWithoutTags = type.substring(type.indexOf("<")+1, type.lastIndexOf(">"));
		String[] parts = genericWithoutTags.split(",");
		ArrayList<String> finalParts = new ArrayList<String>();
		StringBuilder sb = new StringBuilder();
		for(String part : parts) {
			if(sb.length() > 0)
				sb.append(",");
			sb.append(part);
			int gtoccurrences = countOccurrences(sb.toString(), '>');
			int ltoccurrences = countOccurrences(sb.toString(), '<');
			if(gtoccurrences == ltoccurrences) {
				finalParts.add(sb.toString());
				sb = new StringBuilder();
			}
		}
		for(String part : finalParts) {
			if(!part.contains("<") && !part.contains(">")) {
				LeafType leaf = new LeafType(part);
				types.add(leaf);
			}
			else {
				GenericType gen = new GenericType(part);
				types.add(gen);
			}
		}
	}

	private int countOccurrences(String haystack, char needle) {
	    int count = 0;
	    for (int i=0; i < haystack.length(); i++) {
	        if (haystack.charAt(i) == needle) {
	             count++;
	        }
	    }
	    return count;
	}

	public void addType(AbstractType type) {
		types.add(type);
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(getNonQualifiedType());
		sb.append("<");
		int counter = 1;
		for(AbstractType type : types) {
			sb.append(type.toString());
			if(counter < types.size())
				sb.append(", ");
			counter++;
		}
		sb.append(">");
		return sb.toString();
	}
}
