package generator.xml;


import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import gr.uom.java.xmi.UMLClass;
import gr.uom.java.xmi.UMLModel;

import org.w3c.dom.Document;

public abstract class XMLGenerator {
	protected Document document;
	protected UMLModel model;
	protected String element;
	protected List<UMLClass> classes;
	
	public XMLGenerator(UMLModel aModel, String element){
		DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder documentBuilder;
		this.model = aModel;
		this.element = element;
		try {
			documentBuilder = documentBuilderFactory.newDocumentBuilder();
			document = documentBuilder.newDocument();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
		
	public Document getXMLDocument(){
		return document;
	}
	
	protected String getTypeFromFullQualifiedName(String type){
		if(type != null) {
			if(type.contains("<") && type.contains(">")) {
				GenericType gen = new GenericType(type);
				String nonQualifiedType = gen.toString();
				if(type.endsWith("[]"))
					nonQualifiedType += "[]";
				return nonQualifiedType;
			}
			else {
				String nonQualifiedType = type;
				int index = type.lastIndexOf(".");
				if (index == -1)
					nonQualifiedType = type;
				else
					nonQualifiedType = type.substring(index + 1);
				if(nonQualifiedType.endsWith("[][][]"))
					nonQualifiedType = nonQualifiedType.substring(0, nonQualifiedType.length()-4);
				if(nonQualifiedType.endsWith("[][]"))
					nonQualifiedType = nonQualifiedType.substring(0, nonQualifiedType.length()-2);
				return nonQualifiedType;
			}
		}
		return "null";
	}
}

