package generator.xml;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.w3c.dom.Element;

import gr.uom.java.xmi.UMLRealization;
import gr.uom.java.xmi.UMLModel;

public class XMLRealizationGenerator extends XMLGenerator {
	List<UMLRealization> realizationList;
	Set<String> visited = new HashSet<String>();
	Map<String, List<String>> realRelationsMap = new HashMap<String, List<String>>();

	public XMLRealizationGenerator(UMLModel aModel, String element) {
		super(aModel, element);
		classes = model.getClassList();
		realizationList = model.getRealizationList();
		initializerealRelationsMap();
		
		Element root = document.createElement("VirtualRoot");
		root.setAttribute("name", "VirtualRoot");
		for(int i = 0; i < realizationList.size(); i++){
			if (!visited.contains(realizationList.get(i).getClient())){
				Element genElement = inherits(realizationList.get(i).getClient(), false, false);
				if (genElement != null)
					root.appendChild(genElement);
			}
		}
		document.appendChild(root);	
	}
	
	private Element inherits(String parentID, boolean elementFlag, boolean isChild){
		visited.add(parentID);
		Element parentElement;
		if (isChild)
			parentElement = document.createElement("Interface");
		else 
			parentElement = document.createElement("Class");
		parentElement.setAttribute("className", parentID);
		if (parentID.equals(element)) elementFlag = true;
			
		if(!realRelationsMap.containsKey(parentID)) return parentElement;
		if (realRelationsMap.get(parentID) != null){
			List<String> children = realRelationsMap.get(parentID);
			for(String child : children){
				if (element == null) elementFlag = true; 
				else if (child.equals(element)) elementFlag = true;
				Element e =inherits( child, elementFlag, true);
				if (e != null){
					if(parentID.equals(element) && !child.equals(element))
						parentElement.appendChild(e);
				}
			}
		}
		if (elementFlag)
			return parentElement;
		return null;
	}
	private void initializerealRelationsMap(){
		for(int i = 0; i < realizationList.size(); i++)
			if(realRelationsMap.containsKey(realizationList.get(i).getClient()))
			{
				List<String> parents = realRelationsMap.get(realizationList.get(i).getClient());
				parents.add(realizationList.get(i).getSupplier());
				realRelationsMap.put(realizationList.get(i).getClient(), parents);
			}
			else{
				List<String> parents = new ArrayList<String>();
				parents.add(realizationList.get(i).getSupplier());
				realRelationsMap.put(realizationList.get(i).getClient(), parents);
			}
	}

}
