package gr.uom.java.xmi;

public class UMLAttribute  implements Comparable<UMLAttribute> {
	private String name;
	private String type;
	private String visibility;
	private long ID;

	public UMLAttribute(String name, String type, long ID) {
		this.name = name;
		this.type = type;
		this.ID = ID;
	}

	public String getType() {
		return type;
	}
	
	public long getID(){
		return ID;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getVisibility() {
		return visibility;
	}

	public void setVisibility(String visibility) {
		this.visibility = visibility;
	}

	public String getName() {
		return name;
	}

	public boolean equals(Object o) {
		if(this == o) {
    		return true;
    	}
    	
    	if(o instanceof UMLAttribute) {
    		UMLAttribute umlAttribute = (UMLAttribute)o;
    		return this.name.equals(umlAttribute.name) &&
			this.visibility.equals(umlAttribute.visibility) &&
			this.type.equals(umlAttribute.type);
    	}
    	return false;
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(visibility);
		sb.append(" ");
		sb.append(name);
		sb.append(" : ");
		sb.append(type);
		return sb.toString();
	}
	
	 public int compareTo(UMLAttribute attribute) {
	        return this.toString().compareTo(attribute.toString());
	    }
}
