package gr.uom.java.xmi;

public class UMLParameter {
	private String name;
	private String type;
	private String kind;
	private long ID;

	public UMLParameter(String name, String type, String kind, long ID) {
		this.name = name;
		this.type = type;
		if(kind != null)
			this.kind = kind;
		else
			this.kind = "in";
		this.ID = ID;
	}
	
	public long getID(){
		return ID;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getName() {
		return name;
	}

	public String getKind() {
		return kind;
	}

	public boolean equalsIncludingName(UMLParameter parameter) {
		return this.name.equals(parameter.name) &&
		this.type.equals(parameter.type) &&
		this.kind.equals(parameter.kind);
	}

	public boolean equals(Object o) {
		if(this == o) {
            return true;
        }
		
		if(o instanceof UMLParameter) {
			UMLParameter parameter = (UMLParameter)o;
			if(this.type != null && parameter.type != null) {
			return this.type.equals(parameter.type) &&
				this.kind.equals(parameter.kind);
			}
		}
		return false;
	}

	public String toString() {
		if(kind.equals("return"))
			return type;
		else
			return name + " " + type;
	}
}
