package gr.uom.java.xmi.diff;

import gr.uom.java.xmi.AccessedMember;
import gr.uom.java.xmi.FieldAccess;
import gr.uom.java.xmi.MethodCall;

public class AccessedMemberDiff {
	private AccessedMember accessedMember1;
	private AccessedMember accessedMember2;
	
	public AccessedMemberDiff(AccessedMember accessedMember1,
			AccessedMember accessedMember2) {
		this.accessedMember1 = accessedMember1;
		this.accessedMember2 = accessedMember2;
	}
	
	public AccessedMember getAccessedMember1() {
		return accessedMember1;
	}

	public AccessedMember getAccessedMember2() {
		return accessedMember2;
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		if(accessedMember1 instanceof MethodCall && accessedMember2 instanceof MethodCall) {
			sb.append("\t\t").append("Method call " + accessedMember1 + " changed to " + accessedMember2).append("\n");
		}
		if(accessedMember1 instanceof FieldAccess && accessedMember2 instanceof FieldAccess) {
			sb.append("\t\t").append("Field access " + accessedMember1 + " changed to " + accessedMember2).append("\n");
		}
		return sb.toString();
	}
}
