package gr.uom.java.xmi.diff;

import gr.uom.java.xmi.UMLAttribute;

public class UMLAttributeDiff {
	private UMLAttribute removedAttribute;
	private UMLAttribute addedAttribute;
	private boolean visibilityChanged;
	private boolean typeChanged;

	public UMLAttributeDiff(UMLAttribute removedAttribute, UMLAttribute addedAttribute) {
		this.removedAttribute = removedAttribute;
		this.addedAttribute = addedAttribute;
		this.visibilityChanged = false;
		this.typeChanged = false;
		if(!removedAttribute.getVisibility().equals(addedAttribute.getVisibility()))
			visibilityChanged = true;
		if(!removedAttribute.getType().equals(addedAttribute.getType()))
			typeChanged = true;
	}

	public boolean isEmpty() {
		return !visibilityChanged && !typeChanged;
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		if(!isEmpty())
			sb.append("\t").append(removedAttribute).append("\n");
		if(visibilityChanged)
			sb.append("\t").append("visibility changed from " + removedAttribute.getVisibility() + " to " + addedAttribute.getVisibility()).append("\n");
		if(typeChanged)
			sb.append("\t").append("type changed from " + removedAttribute.getType() + " to " + addedAttribute.getType()).append("\n");
		return sb.toString();
	}
}
