package gr.uom.java.xmi.diff;

import gr.uom.java.xmi.UMLGeneralization;

public class UMLGeneralizationDiff implements Comparable<UMLGeneralizationDiff> {
	private UMLGeneralization removedGeneralization;
	private UMLGeneralization addedGeneralization;
	private boolean parentChanged;
	
	public UMLGeneralizationDiff(UMLGeneralization removedGeneralization, UMLGeneralization addedGeneralization) {
		this.removedGeneralization = removedGeneralization;
		this.addedGeneralization = addedGeneralization;
		this.parentChanged = false;
		if(!removedGeneralization.getParent().equals(addedGeneralization.getParent()))
			parentChanged = true;
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		if(parentChanged)
			sb.append("\t").append("generalization ").append(removedGeneralization).append(":").append("\n");
		if(parentChanged)
			sb.append("\t").append("parent changed from " + removedGeneralization.getParent() + " to " + addedGeneralization.getParent()).append("\n");
		return sb.toString();
	}

	public int compareTo(UMLGeneralizationDiff generalizationDiff) {
		int compare = this.removedGeneralization.compareTo(generalizationDiff.removedGeneralization);
		if(compare == 0)
			return this.addedGeneralization.compareTo(generalizationDiff.addedGeneralization);
		else
			return compare;
	}
}
