package model.diff;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.StringTokenizer;

public class PropertiesCreator {
	private PrintStream properties = null;
	private PrintStream schema = null;
	private String config_directory;
	private String root;

	public PropertiesCreator(String cpath){
		
		this.config_directory = cpath;

		StringTokenizer st = new StringTokenizer(config_directory, "/");
		boolean isRoot = true;

		StringBuilder path = new StringBuilder("");

		while(st.hasMoreElements()){
			String token = st.nextToken();
			if (isRoot) {
				root = token;
				path.append(root);
				isRoot= false;
			}
			else {
				path.append("/");
				path.append(token);
			}

			File configFolder = new File(path.toString());
			configFolder.mkdir();
		}

		// Create the config folder in the current directory
		try {
			File configFolder = new File("config");
			boolean created = configFolder.mkdir();
			if(created) {
				properties = new PrintStream(new FileOutputStream(new File("config" + "/RefXMLCostAssessor.properties")));
				createPropertiesFile();
				schema = new PrintStream(new FileOutputStream(new File("config" + "/schema.properties")));
				createSchemaPropertiesFile();
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

	}

//	public void createConfigFolder(){
//		File umlFolder = new File(config_directory + "/UML");
//		umlFolder.mkdir();
//		File resultFolder = new File(config_directory + "/UML/results");
//		resultFolder.mkdir();
//		File v1Folder = new File(config_directory + "/UML/v1");
//		v1Folder.mkdir();
//		File v2Folder = new File(config_directory + "/UML/v2");
//		v2Folder.mkdir();
//	}

	private void createPropertiesFile(){
		properties.println("refXMLCostAssessor.dependencyAttrName=");
		properties.println("refXMLCostAssessor.associateAtrrName=");
		properties.println("refXMLCostAssessor.superNodeAttrName=");
		properties.println("refXMLCostAssessor.idAttrName=|operationName|methodCallName|argType|" +
		"ConstructorCallName|fieldName|className|paramName|actorName|useCaseName|");
		properties.println("refXMLCostAssessor.mergableElements=");
		properties.println("refXMLCostAssessor.inheritanceElementName=");
		properties.println("refXMLCostAssessor.skipElements=");
		properties.println("refXMLCostAssessor.rootElementName=VirtualRoot");
		properties.println("refXMLCostAssessor.keyElementName=|Operation|Attribute|Actor|UseCase|");
		properties.println("refXMLCostAssessor.changePropagationParents=|Operation|");
		properties.println("refXMLCostAssessor.skipNamespaces=");
		properties.println("owl:AnnotationProperty|owl:DatatypeProperty|owl:ObjectProperty|rdfs:Class|owl:OntologyProperty|");
	}

	private void createSchemaPropertiesFile(){
		schema.println("schema.ignoreAttrs=|ID|");
	}

	public String getRootName(){
		if (root != null)
			return root;
		else return "";
	}

}
