package model.diff;

import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import org.apache.log4j.Logger;
import org.w3c.dom.Document;

import vtracker.comparison.operations.EditScript;
import vtracker.comparison.xml.comparator.RefXMLComparator;
import vtracker.comparison.xml.comparator.XMLComparator;
import vtracker.comparison.xml.utils.XMLUtils;

public class VTrackerStandalone {
	public boolean isUsage;
	
	
	static Logger log = Logger.getLogger(VTrackerStandalone.class.getName());
	Properties config;

	public List<EditScriptResult> run(List<XMLStringPair> xmlStringPairs) {
		String costConfig = null;
		int counter = 1;
		float threshold = 100.0f;
		
		List<EditScriptResult> editScripts = new ArrayList<EditScriptResult>();
		
		for(XMLStringPair xmlPair : xmlStringPairs){			
			String relationshipType = xmlPair.getType();
			if (relationshipType.equals("usage")) isUsage = true;
			byte[] result = compareFiles(xmlPair.getFirstXMLString(), xmlPair.getSecondXMLString(),  
					costConfig, threshold, relationshipType);
			if (result != null)
			{
				editScripts.add(new EditScriptResult(result, relationshipType));
			}
			counter++;
		}
		
		return editScripts;
	}

	public byte[] compareFiles(String xmlStr1, String xmlStr2, 
			String costConfig, float threshold,
			String relationshipType) {
		byte[] editScriptResult = null;
		
		try {
	
			Document doc1 = XMLUtils.parseXMLString(xmlStr1);
			Document doc2 = XMLUtils.parseXMLString(xmlStr2);
			
			XMLComparator com = costConfig == null ? new RefXMLComparator(doc1,doc2) : new RefXMLComparator(doc1, doc2, costConfig);
			com.compare(true);
			
			EditScript script = new EditScript(com, isUsage);
			//script.exportEditScript(resultDir + "_edit_script.txt");
			editScriptResult = script.getEditScriptString().getBytes();		
			
		} catch (Exception ex) {
			//log.error(ex, ex);
		}
		
		return editScriptResult;
	}

}
